const mongoose = require("mongoose");
const fsp = require("fs/promises");
const fs = require("fs");
const path = require("path");
const service = require("../config/services");
const log = require('../middlewares/log');


var datosController = {};

datosController.recuperarDatos = async function (req, res) {
  //let nombre = req.query.nombre;
  let nombre = req.usuario;

  if (
    !fs.existsSync(path.join(__dirname, "../UsuariosRegistrados/" + nombre))
  ) {
    log.errorMensaje(req,"No existe el usuario");
    return res
      .status(200)
      .send({ result: null, error: "No existe el usuario" });
  }
  let datos = fs.readFileSync(
    "UsuariosRegistrados/" + nombre + "/datos.json.enc",
    "utf-8"
  );
  log.serverActionInfo(req,"Datos devueltos");
  return res
    .status(200)
    .send({ result: { status: "ok", datos: datos }, error: null });
};

datosController.subirDatos = async function (req, res) {
  //let nombre = req.body.usuario;
  let nombre = req.usuario;

  if (
    !fs.existsSync(path.join(__dirname, "../UsuariosRegistrados/" + nombre))
  ) {
    log.errorMensaje(req,"No existe el usuario");
    return res
      .status(200)
      .send({ result: null, error: "No existe el usuario" });
  }
  await fsp.writeFile('UsuariosRegistrados/' + nombre + '/datos.json.enc', req.body.fichero);
  log.serverActionInfo(req,"Datos subidos");
  return res
    .status(200)
    .send({ result: "ok", error: null });

};

/*
 * Other actions
 */

module.exports = datosController;
